#ifndef __EZMANAGERLIB_H
#define __EZMANAGERLIB_H

//"ezManager library(VC++ SLL) version 2.0B 2012/11/12 by SOLLAE systems Co., LTD."

#include <winsock2.h>
#include <stdio.h>
#include <conio.h>

typedef BYTE			_u8;
typedef WORD			_u16;
typedef DWORD			_u32;

#define PASSWD_SIZE		10
#define MAX_COM_PORT	48
#define MAX_DI			8
#define MAX_DO			8
#define MAX_TCP_SESSION 48

#define IO_SCRIPT_LEN		32
#define IO_COMMENT_LEN		16
#define UART_COMMENT_LEN	32

#define EZTCP_ERR					-1
#define	EZTCP_ERR_PWD				-100
#define	EZTCP_ERR_RES				-200
#define EZTCP_ERR_LOCAL_IP			-300
#define EZTCP_ERR_IO_SCRIPT			-400
#define EZTCP_ERR_IO_ADDR			-500
#define EZTCP_ERR_LOCAL_PORT_100	-600
#define EZTCP_ERR_LOCAL_PORT_101	-601
#define EZTCP_ERR_LOCAL_PORT_102	-602
#define EZTCP_ERR_LOCAL_PORT_103	-603
#define EZTCP_ERR_LOCAL_PORT_104	-604
#define EZTCP_ERR_LOCAL_PORT_105	-605
#define EZTCP_ERR_PRODUCT_MISMATCH	-700 /* product ID mismatch */
#define EZTCP_ERR_UNKNOWN			-800 /* Unknown Error */
#define EZTCP_ERR_NO_INFO			-900
#define EZTCP_ERR_WRONG_WAIT_TIME	-901 /* Invalid wait time value */
#define EZTCP_ERR_NO_NETWORK		-903
#define EZTCP_ERR_FLASH_NOSPACE		-904

#define MUX_TYPE_T2S  0 /* Tcp to Serial */
#define MUX_TYPE_ATC  1 /* AT Command */
#define MUX_TYPE_COD  2 /* Connect On Demand */
#define MUX_TYPE_U2S  3 /* UDP 2 Serial */
#define MUX_TYPE_MOD  4 /* Modbus Client */

#define OLD_PID_CIE_H10		0x10	/* 16 : CIE-H10/M10/H14 */
#define OLD_PID_CSE_H20		0x11	/* 17 : CSE-H20/H21 */
#define OLD_PID_CSE_M32		0x12	/* 18 : CSE-M32 */
#define OLD_PID_CSE_M31		0x13	/* 19 : CSE-M32 SPI */
#define OLD_PID_CSE_M73		0x14	/* 20 : CSE-M73 2 ports board type, RS-232 / 422 / 485 */
#define OLD_PID_CSW_M80		0x15	/* 21 : CSW-H80/M80 */

#define PID_CIE_H10		0x20	/* 32 : CIE-H10 */
#define PID_CIE_M10		0x21	/* 33 : CIE-M10 */
#define PID_CIE_H14		0x22	/* 34 : CIE-H14 */
#define PID_CSE_M32		0x23	/* 35 : CSE-M32 */
#define PID_CSE_H20		0x24	/* 36 : CSE-H20 */
#define PID_CSE_H21		0x25	/* 37 : CSE-H21 */
#define PID_CSE_M73		0x26	/* 38 : CSE-M73 */
#define PID_CSW_H80		0x27	/* 39 : CSW-H80 */
#define PID_CSW_M80		0x28	/* 40 : CSW-M80 */
#define PID_CSE_H25		0x29	/* 41 : CSE-H25 */
#define PID_CSE_M51		0x2a	/* 42 : CSE-M51 */
#define PID_CSE_M53		0x2b	/* 43 : CSE-M53 */
#define PID_CSE_H53		0x2c	/* 44 : CSE-H53 */
#define PID_CSW_M83		0x2d	/* 45 : CSW-M83 */
#define PID_CSW_M85		0x2e	/* 46 : CSW-M85 */
#define PID_CSE_H55		0x2f	/* 47 : CSE-H55 */
#define PID_CSC_HR2		0x30	/* 48 : CSC-HR2 */
#define PID_CSC_HR3		0x32	/* 50 : CSC-HR3 */
#define PID_CUE_H40		0x33	/* 51 : CUE-H40 */
#define PID_CIE_H12		0x34	/* 52 : CIE-H12 */
#define PID_CSW_H85		0x35	/* 53 : CSW-H85 */
#define PID_CSE_T32		0x36	/* 54 : CSE-T32 */
#define PID_CSE_M53A	0x37	/* 55 : CSE-M53A */
#define PID_CSE_T16		0x39	/* 57 : CSE-T16 */
#define PID_CSE_T48		0x3a	/* 58 : CSE-T48 */
#define PID_CSE_H53A	0x3b	/* 59 : CSE-H53A */
#define PID_CSW_M84		0x3c	/* 60 : CSE-M84 */
#define PID_CSE_M53N	0x3d	/* 61 : CSE-M53N */
#define PID_CSE_H53N	0x3e	/* 62 : CSE-H53N */
#define PID_CSE_H55N	0x3f	/* 63 : CSE-H55N */


#define MK_IP(__b1,__b2,__b3,__b4) \
( ((unsigned long)(__b4) << 24) | ((unsigned long)(__b3) << 16) | \
  ((unsigned long)(__b2) <<  8) | ((unsigned long)(__b1)) )

struct net_env
{
	_u8		mac_addr		[6];		
	_u8		secure			[6];			
	_u16	major;				
	_u16	minor;				
	_u32	local_ip;			
	_u32	net_mask;			
	_u32	gate_ip;			
	_u8		pppoe_id		[32];		
	_u8     pppoe_pwd		[16];		
	_u32	socket_ip;			
	_u32	dns_ip;				
	_u16	product_id_old;		
	_u16	product_id_new;		
	_u8		ddns_id			[32];		
	_u8		ddns_pwd		[16];		
	_u8		ddns_host_name	[64];
	_u8		ssh_id			[16];
	_u8		ssh_pwd			[16];
};

struct uart_dev_env
{
	unsigned int max_stype		: 2;
	unsigned int stype			: 2;
	unsigned int databit		: 2;
	unsigned int stopbit		: 2;

	unsigned int parity			: 2;
	unsigned int flowctrl		: 2;
	unsigned int telcom			: 2;
	unsigned int parity2		: 2;

	unsigned int en_ttl			: 1;
	unsigned int ttl			: 1;
	unsigned int en_tx_delay	: 1;
	unsigned int tx_delay		: 5;
	unsigned int dtrdsr			: 1;
	unsigned int pad0			: 1;
	unsigned int pad2			: 6;
	_u32		 max_baud;
	_u32		 sio_baud;		
};

struct uart_var_env
{
	_u32	local_ip;		
	_u32	peer_ip;		
	_u16	local_port;    
	_u16	peer_port;		
	_u8		mux_type;		
	_u8		no_delay	:1;
	_u8		cod_listen	:1;
	_u8		secure		:2;	// 0 : none, 1 : ssl, 2, 3 : reserved.
	_u8		pad			:4;	
	_u16	water_mark;	
	_u16	time_mark;		
	_u16	timeout;		
};

//===============================================
struct uart_del_env
{
	_u8		del_char[4];		
	_u16	del_len		: 3;	
	_u16	pad			: 5;	
	_u16	max_type	: 4;
	_u16	del_type	: 4;	
	_u16	pad1;				
};
//===============================================

struct uart_env
{
	struct uart_dev_env		uart_dev_env;				
	struct uart_var_env		uart_var_env;				
	struct uart_del_env		uart_del_env;				
	_u8						host_name	[64];				
	_u8						comment		[UART_COMMENT_LEN];	
	_u32					use_flag;					
};

struct opt_env
{
	/* basic network options */
	unsigned int ezcfg_lock : 1;
	unsigned int rcfg		: 1;
	unsigned int arp		: 1;
	unsigned int dhcp		: 1;
	unsigned int pppoe		: 1;
	unsigned int auto_ns	: 1;
	unsigned int pad0		: 2;
	unsigned int ip6		: 1;
	unsigned int ip6_eui	: 2;
	unsigned int ip6_gua	: 2;
	unsigned int pad1		: 3;

	/* application options */
	unsigned int debug	: 1;
	unsigned int telnet : 1;
	unsigned int ssl    : 1;
	unsigned int ssh    : 1;
	unsigned int http   : 1;
	unsigned int ddns	: 3;
	unsigned int t2smc  : 1;
	unsigned int secure	: 1;	
	unsigned int mac_id : 1;
	unsigned int ps		: 1;
	unsigned int pd		: 1;
	unsigned int pad3	: 3;	
};

struct ip6_env
{
	_u8		ip6_gua			[16];
	_u16	ip6_gua_prefix;
	_u16	pad0;								
	_u8		ip6_gateway		[16];
	_u8		ip6_dns			[16];
	_u8		ip6_uart_peer	[MAX_COM_PORT][16];
};

struct etc_env
{
	_u8		allow_mac		[6];			
	_u8		pad0			[2];				
	_u32	allow_ip;				
	_u32	allow_subnet;			
	_u8		comment			[64];			
	_u8		pwd_old			[PASSWD_SIZE];	
	_u8		pwd				[PASSWD_SIZE];		
	_u8		allow_ip6		[16];			
	_u32	allow_ip6_prefix;					
};

struct io_var_env
{
	unsigned int	modbus			: 1;
	unsigned int	macro			: 1;
	unsigned int	master			: 1;
	unsigned int	active			: 1;
	unsigned int	notify			: 1; 
	unsigned int	conns			: 3;
	unsigned int	emacro			: 8;	
	unsigned int	query			: 1;
	unsigned int	ctrl			: 1;
	unsigned int	pad0			: 6;	
	unsigned int	pad1			: 8;	
	_u32			peer_ip;				
	_u16			peer_port;				
	_u16			slave_id;				
	_u16			input_addr;			
	_u16			output_addr;			
	_u32			init_output;			
	_u32			poll_interval;			
	_u16			input_valid_time[8];	
	_u16			output_delay	[8];		
};

struct io_env
{
	_u8					di_num;								
	_u8					do_num;								
	_u16				html_size;							
	_u8					script		[MAX_DO][IO_SCRIPT_LEN];		
	_u8					host_name	[64];						
	_u8					di_comment	[MAX_DI][IO_COMMENT_LEN];	
	_u8					do_comment	[MAX_DO][IO_COMMENT_LEN];	
	struct io_var_env	io_var_env;		
	_u32				use_flag;							
};

struct ip_trap_env
{
	unsigned int	level : 3; 
	unsigned int	pad0  : 13;			
	unsigned int	pad1  : 16;			
	_u32			peer_ip;						
	_u16			peer_port;						
	_u16			interval;						
};

struct port_map_env
{
	_u16 http_port;	
	_u16 reserved1;	
	_u16 reserved2;	
	_u16 reserved3;	
	_u16 reserved4;	
};

struct wlan_opt
{
	unsigned int cctype			: 4;
	unsigned int channel		: 4;
	unsigned int wep			: 2;
	unsigned int wep_id			: 2;
	unsigned int pad0			: 1;
	unsigned int bg_scan		: 1;
	unsigned int auth			: 2;
	unsigned int wpa			: 3;
	unsigned int cipher			: 2;
	unsigned int pad1			: 3;
	unsigned int antenna		: 1;
	unsigned int phy			: 3;
	unsigned int short_preamble	: 1;
	unsigned int short_slot		: 1;
	unsigned int cts_protection	: 1;
	unsigned int pad2			: 1;		
};

struct wlan_var
{
	_u8 ssid			[32];		
	_u8 key40			[4][5];		
	_u8 key104			[4][13];	
	_u8 wpa_passphrase	[64];		
	_u8 wpa_psk			[32];		
	_u8 power_table		[16];		
	_u8 pad0			[3];		
	_u8 key_flag;			
	_u8 eap_id			[32];
	_u8	eap_pwd			[16];
};

struct wlan_env
{
	struct wlan_opt		wlan_opt_env;
	struct wlan_var		wlan_var_env;	
	_u32				use_flag;		
};

struct tcp_status_env
{
	_u8		stat;			
	_u8		pad1;			
	_u16	winq_out;		
	char	name[8];		
	_u32	local_ip;		
	_u32	peer_ip;		
	_u16	local_port;	
	_u16	peer_port;		
};

struct tcp6_status_env
{
	_u8		stat;			
	_u8		pad1;			
	_u16	winq_out;		
	char	name		[8];		
	_u8		local_ip6	[16];	
	_u8		peer_ip6	[16];	
	_u16	local_port;		
	_u16	peer_port;		
};

struct redundancy_var_env
{
	_u32 peer_ip	[2];    
	_u16 peer_port	[2];	
	_u16 timeout	[2];    
	_u16 threshold	[2];    
	_u16 check_port;		
	_u16 pad0;
};

struct csc_hr2_env
{
	struct uart_dev_env			uart_dev_env;
	_u8							mux_type;
	_u8							pad					[3];
	_u8							csc_hr2_id			[16];
	_u8							server_host_name1	[64];
	_u8							server_host_name2	[64];
	struct redundancy_var_env	redundancy_var_env;
};

struct lib_env
{
	struct net_env				net_env;							
	struct ip6_env				ip6_env;
	struct uart_env				uart_env[MAX_COM_PORT];				
	struct opt_env				opt_env;							
	struct etc_env				etc_env;							
	struct io_env				io_env;								
	struct ip_trap_env			ip_trap_env;						
	struct port_map_env			port_map_env;						
	struct wlan_env				wlan_env;							
	struct csc_hr2_env			csc_hr2_env;						
};

//=======================================================================================================
// Main functions.
void Exit_Library(void);

//----------------------------------------------------------------------
int EzManager_Search	(	int				mode, 
							_u32			ip, 
							struct lib_env	*lib_env, 
							int				*result_count, 
							int				*error,
							int				port	= 0,
							_u32			bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_Read		(	int				mode,
							_u8				*mac_addr,
							_u32			ip,
							struct lib_env	*lib_env,
							int				*error,
							int				port	= 0,
							_u32			bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_Write		(	int				mode, 
							struct lib_env	*lib_env, 
							_u8				*cur_pwd, 
							int				*error,
							int				port	= 0,
							_u32			bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_Status	(	int						mode, 
							struct lib_env			*lib_env, 
							_u8						*stat_buf, 
							int						stat_buf_len, 
							struct tcp_status_env	*tcp_status_env, 
							int						*tcp_session_count, 
							int						*error,
							int						port	= 0,
							_u32					bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_ChangePwd	(	int				mode, 
							struct lib_env	*lib_env, 
							_u8				*cur_pwd, 
							_u8				*new_pwd, 
							int				*error,
							int				port	= 0,
							_u32			bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_CloseTCP	(	int						mode,
							struct lib_env			*lib_env,
							struct tcp_status_env	*tcp_status_env,
							_u8						*cur_pwd,
							int						*error,
							int						port	= 0,
							_u32					bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_RdbOnOff	(	int		mode,
							_u8		*mac_addr,
							_u32	eztcp_ip,
							BOOL	onoff,
							_u32	rcvd_ip,
							int		*error,
							int		port	= 0,
							_u32	bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
int EzManager_ReBoot	(	int		mode,
							_u8		*mac_addr,
							_u32	eztcp_ip,
							int		*error,
							int		port	= 0,
							_u32	bind_ip	= 0);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
char* GetLibVer		(int	*len);
//----------------------------------------------------------------------

//----------------------------------------------------------------------
char* GetProductName(int	product_id, int* len);
//----------------------------------------------------------------------
//=======================================================================================================

#endif
